﻿using System;
using System.Collections.Generic;
using System.Windows;
using Infragistics.Controls.Grids;

namespace XamGridGroupColumnWidthBug
{
    public partial class MainPage
    {
        public class MyData
        {
            public string Col1 { get; set; }
            public string Col2 { get; set; }
            public double Col3 { get; set; }
            public double Col4 { get; set; }
        }

        List<MyData> myData = new List<MyData>();

        public MainPage()
        {
            InitializeComponent();

            this.DataContext = this;

            var msg = "1. Why is there a scrollbar ?\r\n2. Increasing this columns width(by dragging) - increases the scrollbar. WHY ?\r\nThere are only auto + star columns  ??? \r\nThere shouldnt be a scrollbar at all since there are no fixed width's anywhere !";
            for (int i = 0; i < 10; i++)
            {
                myData.Add(
                    new MyData
                    {
                        Col1 = i == 0 ? msg : string.Empty,
                        Col2 = Guid.NewGuid().ToString(),
                        Col3 = new Random(i).Next(9999, 9999999),
                    });
            }

            Loaded += MainPage_Loaded;
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            myGrid.ItemsSource = myData;
        }

        private void myGrid_ColumnLayoutAssigned(object sender, ColumnLayoutAssignedEventArgs e)
        {
            var theNewColumnLayout = e.ColumnLayout;
            if (theNewColumnLayout.Columns.Count > 0)
                theNewColumnLayout.Columns.Clear();

            // group cols
            var groupColumn1 = new GroupColumn { Key = "GroupColumn1", HeaderText = "GroupColumn1 - ColumnWidth=Star", Width = ColumnWidth.Star };
            var groupColumn2 = new GroupColumn { Key = "GroupColumn2", HeaderText = "GroupColumn2 - ColumnWidth=Star", Width = ColumnWidth.Star };

            // cols
            var col1 = new TextColumn { Key = "Col1", HeaderText = "ColumnWidth=Auto", Width = ColumnWidth.Auto };
            var col2 = new TextColumn { Key = "Col2", HeaderText = "ColumnWidth=Auto", Width = ColumnWidth.Auto };
            var col3 = new TextColumn { Key = "Col3", HeaderText = "ColumnWidth=Star", Width = ColumnWidth.Star };

            // Cols to Gc -> Numbers
            groupColumn2.Columns.Add(col2);
            groupColumn2.Columns.Add(col3);

            // group cols to Top
            groupColumn1.Columns.Add(col1);
            groupColumn1.Columns.Add(groupColumn2);

            theNewColumnLayout.Columns.Add(groupColumn1);
        }
    }
}
